Example #1
0
 public static Dictionary <string, object> StiffnessMatrix4Type(ModellingTools.StiffnessMatrix4Type stiffnessMatrix)
 {
     return(new Dictionary <string, object>
     {
         { "XX", stiffnessMatrix.XX },
         { "XY", stiffnessMatrix.XY },
         { "YY", stiffnessMatrix.YY },
         { "GXY", stiffnessMatrix.GXY }
     });
 }
Example #2
0
 /// <summary>
 /// Construct virtual shell
 /// </summary>
 /// <param name="region"></param>
 /// <param name="membraneStiffness"></param>
 /// <param name="flexuralStiffness"></param>
 /// <param name="shearStiffness"></param>
 /// <param name="density"></param>
 /// <param name="t1"></param>
 /// <param name="t2"></param>
 /// <param name="alpha1"></param>
 /// <param name="alpha2"></param>
 /// <param name="ignoreInStImpCalc"></param>
 /// <param name="identifier"></param>
 public FictitiousShell(Geometry.Region region, StiffnessMatrix4Type membraneStiffness, StiffnessMatrix4Type flexuralStiffness, StiffnessMatrix2Type shearStiffness, double density, double t1, double t2, double alpha1, double alpha2, bool ignoreInStImpCalc, double meshSize, string identifier)
 {
     this.EntityCreated();
     this.Region            = region;
     this.CoordinateSystem  = region.CoordinateSystem;
     this.MembraneStiffness = membraneStiffness;
     this.FlexuralStiffness = flexuralStiffness;
     this.ShearStiffness    = shearStiffness;
     this.Density           = density;
     this.T1     = t1;
     this.T2     = t2;
     this.Alpha1 = alpha1;
     this.Alpha2 = alpha2;
     this.IgnoreInStImpCalculation = ignoreInStImpCalc;
     this.MeshSize   = meshSize;
     this.Identifier = identifier;
 }
Example #3
0
        public static FictitiousShell Define(Autodesk.DesignScript.Geometry.Surface surface, StiffnessMatrix4Type d, StiffnessMatrix4Type k, StiffnessMatrix2Type h, double density, double t1, double t2, double alpha1, double alpha2, bool ignoreInStImpCalc, [DefaultArgument("EdgeConnection.Default()")] Shells.EdgeConnection edgeConnection, [DefaultArgument("Autodesk.DesignScript.Geometry.Vector.ByCoordinates(0,0,0)")] Autodesk.DesignScript.Geometry.Vector localX, [DefaultArgument("Autodesk.DesignScript.Geometry.Vector.ByCoordinates(0,0,0)")] Autodesk.DesignScript.Geometry.Vector localZ, double avgSrfElemSize = 0, string identifier = "FS")
        {
            // convert geometry
            Geometry.Region     region = Geometry.Region.FromDynamo(surface);
            Geometry.FdVector3d x      = Geometry.FdVector3d.FromDynamo(localX);
            Geometry.FdVector3d z      = Geometry.FdVector3d.FromDynamo(localZ);

            // add edge connections to region
            region.SetEdgeConnections(edgeConnection);

            //
            FictitiousShell obj = new FictitiousShell(region, d, k, h, density, t1, t2, alpha1, alpha2, ignoreInStImpCalc, avgSrfElemSize, identifier);

            // set local x-axis
            if (!localX.Equals(Autodesk.DesignScript.Geometry.Vector.ByCoordinates(0, 0, 0)))
            {
                obj.LocalX = FemDesign.Geometry.FdVector3d.FromDynamo(localX);
            }

            // set local z-axis
            if (!localZ.Equals(Autodesk.DesignScript.Geometry.Vector.ByCoordinates(0, 0, 0)))
            {
                obj.LocalZ = FemDesign.Geometry.FdVector3d.FromDynamo(localZ);
            }

            // return
            return(obj);
        }